#ifndef _SIMPLE_PROMOTE_MOVE_ACTION_H
#define _SIMPLE_PROMOTE_MOVE_ACTION_H

#include "osl/move_action/concept.h"
namespace osl
{
  namespace effect_action
  {
    /**
     * Promote と違って，simpleMove を呼ぶ
     */
    template<class Action>
    class SimplePromote
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    private:
      Action & ac;
    public:
      explicit SimplePromote(Action & a) :ac(a){}
      template<Player P,Ptype Type>
      void doActionPtype(Piece p1,Position to)
      {
	Position from=p1.position();
	if (p1.isPromoted())
	  ac.simpleMove(from,to,promote(Type),false,P);
	else if (canPromote(Type) 
		 && (to.canPromote<P>() || from.canPromote<P>()))
	  ac.simpleMove(from,to,promote(Type),true,P);
      }
      template<Player P>
      void doAction(Piece p1,Position to){
	Position from=p1.position();
	Ptype ptype=p1.ptype();
	if (ptype.isPromoted())
	  ac.simpleMove(from,to,ptype,false,P);
	else if (canPromote(ptype) 
		 && (to.canPromote<P>() || from.canPromote<P>()))
	  ac.simpleMove(from,to,promote(ptype),true,P);
      }
      bool done() const{ return false;}
    };

  } // namespace effect_action
} // namespace osl
#endif
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
