/* generateCaptureMoves.tcc
 */
#ifndef _GENERATECAPTUREMOVES_TCC
#define _GENERATECAPTUREMOVES_TCC

#include "osl/move_generator/capture_.h"
#include "osl/effect_action/alwaysMove.h"
#include "osl/effect_action/betterToPromote.h"
#include "osl/player.h"

namespace osl
{
  namespace move_generator
  {
    using namespace effect_action;

    template<Player P>
    template<class Action>
    void Capture<P>::
    generate(const NumEffectState& state,Position target,Action& action)
    {
      assert(target.isOnBoard());
      AlwaysMove<Action> captureAction(state, action);
      state.template forEachEffect<P,AlwaysMove<Action> >(target,captureAction);
    }

    template<Player P>
    template<class Action>
    void Capture<P>::
    generateShouldPromote(const NumEffectState& state,Position target,Action& base)
    {
      assert(target.isOnBoard());
      typedef BetterToPromote<Action> filter_t;
      filter_t filter(state, base);
      state.template forEachEffect<P, filter_t>(target, filter);
    }

    template<Player P>
    template<class Action>
    void Capture<P>::
    escapeByCapture(const NumEffectState& state,Position target,Piece piece,Action& action)
    {
      AlwaysMove<Action> captureAction(state, action);
      state.template forEachEffectNotBy<P,AlwaysMove<Action> >(target,piece,captureAction);
    }

  } // namespace move_generator
} // namespace osl

#endif /* _GENERATECAPTUREMOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
