/* generateCaptureMoves.cc
 */
#include "osl/move_generator/capture_.h"
#include "osl/move_generator/capture_.tcc"
#include "osl/move_action/store.h"
#include "osl/move_action/notKingOpenFilter.h"
#include "osl/container/moveVector.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  namespace move_generator
  {
    using namespace move_action;
    // explicit template instantiation
    template void GenerateCapture::generate(Player,const NumEffectState&, 
					    Position, Store&);

    // escape
    template void GenerateCapture::escapeByCapture
    (Player,const NumEffectState&, Position, Piece, Store&);
    typedef NotKingOpenFilter<BLACK,Store> not_open_black_t;
    typedef NotKingOpenFilter<WHITE,Store> not_open_white_t;
    template void Capture<BLACK>::escapeByCapture
    (const NumEffectState&, Position, Piece, not_open_black_t&);
    template void Capture<WHITE>::escapeByCapture
    (const NumEffectState&, Position, Piece, not_open_white_t&);

    template void Capture<BLACK>::
    escapeByCapture<Store>(NumEffectState const&, Position, Piece, Store&);
    template void Capture<WHITE>::
    escapeByCapture<Store>(NumEffectState const&, Position, Piece, Store&);
    template void Capture<BLACK>::generate<Store>(NumEffectState const&, Position, Store&);
    template void Capture<WHITE>::generate<Store>(NumEffectState const&, Position, Store&);

    template void Capture<BLACK>::generateShouldPromote<Store>(NumEffectState const&, Position, Store&);
    template void Capture<WHITE>::generateShouldPromote<Store>(NumEffectState const&, Position, Store&);
  } // namespace move_generator
} // namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
